



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CSS3那些不为人知的高级属性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CSS3那些不为人知的高级属性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 18:25:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>尽管现代浏览器已经支持了众多的CSS3属性，但是大部分设计师和开发人员貌似依然在关注于一些很&ldquo;主流&rdquo;的属性，如border-radius、box-shadow或者transform等。它们有良好的文档、很好的测试并且最常用到，所以如果你最近在设计网站，你很难能脱离它们。</p>
<p>但是，隐藏在浏览器的大宝库中是一些高级的、被严重低估的属性，但是它们并没有得到太多的关注。或许它们中的一些应该这样(被无视)，但是其它的属性应该得到更多的认可。最伟大的财富隐藏在Webkit的下面，而且在iPhone、iPad和Android apps的时代，开始了解它们会灰常有用。就连Firefox等使用的Gecko引擎，也提供了一些独特的属性。在本文中，我们将看一下鲜为人知的CSS 2.1和CSS3属性以及它们在现代浏览器中的支持情况。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/title1.jpg" /></p>
<p><strong>说明:</strong>&nbsp;对于每个属性，我们这里规定：&rdquo;<strong>WebKit</strong>&rdquo; 即指代使用Webkit内核的浏览器(Safari、Chrome、iPhone、iPad、Android等)，&rdquo;<strong>Gecko</strong>&ldquo;指代采用Gecko内核的浏览器(Firefox等)。然后有的属性是官方<a href="http://www.w3.org/TR/CSS21" rel="external nofollow noreferrer"><strong>CSS 2.1.</strong></a>&nbsp;规范的一部分，这意味着更多的浏览器甚至一些古老的浏览器也会支持它们。最后，一个<a href="http://www.w3.org/Style/CSS/current-work" rel="external nofollow noreferrer"><strong>CSS3</strong></a>&nbsp;的标签标明遵守这个标准，被最新的浏览器版本&mdash;&mdash;比如Firefox 4、Chrome 10、Safari 5、Opera 11.10以及IE9支持的属性。</p>
<h3>WebKit特有属性</h3>
<h4>-webkit-mask</h4>
<p>这个属性是相当强大的，所以详细的介绍超出了本文的范畴，它非常值得深入研究，因为它可以在实际应用中为你省掉很多时间。</p>
<p>-webkit-mask让为一个元素添加蒙板成为可能，从而你可以创建任意形状的花样。蒙板可以是CSS3渐变或者半透明的PNG图片。蒙板元素的alpha值为0的时候会覆盖下面的元素，为1的时候会完全显示下面的内容。相关的属性有-webkit-mask-clip、 -webkit-mask-position 和-webkit-mask-repeat等，严重依赖来自于background中的语法。更多信息请查看<a href="http://www.webkit.org/blog/181/css-masks" rel="external nofollow noreferrer">webkit的博客</a>和下面的链接。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/webkitmask2.jpg" /></p>
<p><strong>示例</strong></p>
<p>图片蒙板:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">.element{<br />
background: url(img/image.jpg) repeat;<br />
-webkit-mask: url(img/mask.png);<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>示例</strong></p>
<p>渐变蒙板:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">.element2 {<br />
background: url(img/image.jpg) repeat;<br />
-webkit-mask: -webkit-gradient(linear, left top, left bottom, from(rgba(0,0,0,1)), to(rgba(0,0,0,0)));<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-SW17" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-text-stroke</h4>
<p>CSS边框的一个不足就是只有矩形的元素才能使用。-webkit-text-stroke可以为文字添加边框。它不但可以设置文字边框的宽度，也能设置其颜色。而且，配合使用color: transparent属性，你还可以创建镂空的字体！</p>
<p><strong>示例</strong></p>
<p>为所有的&lt;h1&gt;标题设定一个2px宽的蓝色边框:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">h1 {-webkit-text-stroke: 2px blue}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>另一个特性是，通过设定1px的透明边框，可以让文字变得平滑:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">h2 {-webkit-text-stroke: 1px transparent}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>创建红色镂空字体：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">h3 {<br />
color: transparent;<br />
-webkit-text-stroke: 4px red;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/webkittextstroke.jpg" /></p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/css/property/-webkit-text-stroke" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-nbsp-mode</h4>
<p>换行有时是很棘手的事情：有时你希望文字在适当的地方断行(而不是折行)，有时你又不想这样。一个能控制这个的属性就是-webkit-nbsp-mode，它让你可以改变&amp;nbsp;空白符的行为，强制文字在它被用到的地方断行。通过设置值为space即可实现。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266--webkit-nbsp-mode" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-tap-highlight-color</h4>
<p>这个属性只用于iOS (iPhone和iPad)。当你点击一个链接或者通过Javascript定义的可点击元素的时候，它就会出现一个半透明的灰色背景。要重设这个表现，你可以设置-webkit-tap-highlight-color为任何颜色。</p>
<p>想要禁用这个高亮，设置颜色的alpha值为0即可。</p>
<p><strong>示例</strong></p>
<p>设置高亮色为50%透明的红色:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">-webkit-tap-highlight-color: rgba(255,0,0,0.5);</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>浏览器支持</strong>: 只有iOS(iPhone和iPad).</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/#documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-_webkit_tap_highlight_color" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>zoom: reset</h4>
<p>通常来说，zoom是一个IE专用的属性。但是webkit也开始支持它了，而且使用值reset，webkit可以实现不错的效果(有趣的是，IE不支持这个值)。它让你重设掉浏览器中正常的缩放行为&mdash;&mdash;如果某个元素被声明了zoom:reset，页面上的<strong>其它元素</strong>在用户放大页面的时候都会跟着放大。</p>
<p>注：其实，我们常用来禁用chrome强制字体大小的时候用到的-webkit-text-size-adjust:none;也是可以实现类似的效果，不同的是，设置该属性的元素内的文字不会被放大/缩小，但是页面上的其它元素则会变化&mdash;&mdash;神飞</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-SW15" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-margin-collapse</h4>
<p>这个属性属于限制级的，但是它还是非常值得关注。通常，两个相邻的元素的margin会折叠起来(collapse)。这意味着第一个元素的底部的边距和第二个元素的头部边距会被合并到一起。</p>
<p>最常见的例子就是两个相邻的&lt;p&gt;元素会共享他们的margin值。想要控制这个表现，我们可以使用-webkit-margin-collapse及其分拆后的-webkit-margin-top-collapse、-webkit-margin-bottom-collapse等属性。默认值是collapse，值separate则停止共享margin值，也就是说，第一个元素的底部边距和第二个元素的头部边距会正常叠加。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/webkitmargincollapse.jpg" /></p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266--webkit-margin-collapse" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-box-reflect</h4>
<p>你还记得几乎每个网站都把他们的网站logo或者头部的文字做成倒影的那个年代吗？谢天谢地，那个年代已经过去了，但是如果你要在一些按钮、导航、或者其他UI元素上更好的使用这个技术，-webkit-box-reflect是更好的选择。</p>
<p>这个属性接受above、below、left和right四个关键词，它们设置倒影的方向，它们和一个设置元素和它的倒影建的距离的数字一起使用。同时，蒙板图片也是同样支持的(看上面的-webkit-mask部分，不要搞混了哈)。倒影会自动生成并对布局<strong>没有影响</strong>。下面的元素只用了CSS，第二个按钮用了-webkit-box-reflect属性。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/webkitboxreflect.jpg" /></p>
<p><strong>示例</strong></p>
<p>这个倒影会出现在它的父元素的下面并有5px的间距:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">-webkit-box-reflect: below 5px;</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>这个倒影会投射到元素的右边，没有间距。然后，一个蒙板将会被应用(url(mask.png)):</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">-webkit-box-reflect: right 0 url(mask.png);</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-SW16" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>-webkit-marquee</h4>
<p>另一个属性让我们回到美好的从前：那个遍地marquee(跑马灯)的年代。有趣的是这个已经被遗弃的标签反而在现在变的很有用，比如我们在比较小的手机屏幕上切换内容，如果不断行的话文字将不能完全显示。</p>
<p><a href="http://i.ozpda.com/ozweather/" rel="external nofollow noreferrer">ozPDA</a>创建的这个天气的应用很好的使用了它。 (如果你木有看到变换的文字，可以尝试换一个城市来体验。需要使用WebKit内核浏览器)</p>
<p><strong>示例</strong></p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8
</pre>
</td>
<td>
<pre class="prettyprint linenums">.marquee {<br />
white-space: nowrap;<br />
overflow:-webkit-marquee;<br />
width: 70px;<br />
-webkit-marquee-direction: forwards;<br />
-webkit-marquee-speed: slow;<br />
-webkit-marquee-style: alternate;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>要让marquee工作需要一些前提条件。首先，white-space必须设置为nowrap，这样才能让文字不自动换行，其次，overflow必须设置为-webkit-marquee，宽度也要设置为比文字实际长度小的数值。</p>
<p>剩下的属性确保文字从左边滚动到右边(-webkit-marquee-direction)、来回移动(-webkit-marquee-style)以及以比较低的速度移动(-webkit-marquee-speed)。其它的属性有-webkit-marquee-repetition，用来定义marquee重复的次数，-webkit-marquee-increment, 定义每次递增的速度变化。</p>
<p>注：虽然HTML的marquee标签在XHTML中被抛弃了，但是各浏览器还是支持的，但是有一个问题就是，marquee标签可能会占用比较大的cpu，<a href="http://ooxx.me/" rel="external nofollow noreferrer">大猫</a>对其进行了深入的研究，结论是marquee的速度不能太快，而webkit用-webkit-marquee属性是最好的&mdash;&mdash;神飞。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-_webkit_marquee" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h3>Gecko特有属性</h3>
<h4>font-size-adjust</h4>
<p>这个有用的CSS3属性目前只有Firefox支持。我们可以用它来设定指定元素的文字大小(font-size)应该相对于小写字母的高度(x-height)而不是大写字母的高度(cap height)。比如，Verdana比同型号的Times字体更清晰，它有着更矮的x-height。为了弥补这个缺陷，我们可以用font-size-adjust属性来纠正后者。</p>
<p>该属性在拥有不同的x-height的字体上非常有用。即便你在小心的使用小号字体，在问题出现时font-size-adjust也能提供解决方案。</p>
<p><strong>示例</strong></p>
<p>如果由于某种原因用户的电脑上没有安装Verdana，那么Arial就会被修正，从而和Verdana有相同的长宽比(0.58)。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5
</pre>
</td>
<td>
<pre class="prettyprint linenums">p {<br />
font-family:Verdana, Arial, sans-serif;<br />
font-size: 12px;<br />
font-size-adjust: 0.58;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/fontsizeadjust.jpg" /></p>
<p><strong>浏览器支持</strong>: Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="https://developer.mozilla.org/en/CSS/font-size-adjust" rel="external nofollow noreferrer">Mozilla Developer Network</a></p>
<h4>image-rendering</h4>
<p>n年前，图片并不会被按照其原始大小显示，而是被设计师给缩放掉。取决于缩放的大小和上下文，图片可能会在浏览器中展现的不太好或者干脆就是错掉了的。现在，浏览器有了更好的算法来显示缩放的图片，不过，在你的图片被缩放后完全的控制其表现也是件很赞的事情。</p>
<p>如果你的图片有比较锐的线条并希望他们在缩放后保持它，这个Gecko私有属性就显得特别有用。相关的值是-moz-crisp-edges。同样的算法也用在optimizeSpeed，而auto 和optimizeQuality 定义为标准行为(用可行的最佳质量来缩放元素)。 image-rendering 属性同样可以用于&lt;video&gt; 和&lt;canvas&gt;元素，和用于背景图片一样。这是个CSS3 标准属性，但是目前只有Firefox支持。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/imagerendering.jpg" /></p>
<p>值得注意的是，-ms-interpolation-mode: bicubic，尽管它是个IE专有属性。然而，它让Internet Explorer 7 在缩放图片后将其渲染为比较高的质量。由于这个浏览器默认处理的很烂，所以这个属性可能会很有用。</p>
<p><strong>浏览器支持</strong>: Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="https://developer.mozilla.org/en/CSS/image-rendering" rel="external nofollow noreferrer">Mozilla Developer Network</a></p>
<h4>-moz-border-top-colors</h4>
<p>这个属性可以归类为&rsquo;养眼&rsquo;。它让你可以在border宽度大于1px的时候为其设置不同的边框颜色。当然-moz-border-bottom-colors, -moz-border-left-colors 和-moz-border-right-colors也是可用的。</p>
<p>不爽的是，没有一个简写的-moz-border-colors 缩写，所以每个边框都要分开设置。同时，border-width要和给到的颜色的数量保持一致，否则，最后的那个颜色值会填充到剩下的宽度。</p>
<p><strong>示例</strong></p>
<p>这个例子中，元素的左右两边边框会是标准的橙色，上下则有种类似渐变的颜色&mdash;&mdash;红黄蓝三色。</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5
</pre>
</td>
<td>
<pre class="prettyprint linenums">div {<br />
border: 3px solid orange;<br />
-moz-border-top-colors: red yellow blue;<br />
-moz-border-bottom-colors: red yellow blue;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/mozbordercolors.jpg" /></p>
<p><strong>浏览器支持</strong>: Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="https://developer.mozilla.org/en/CSS/-moz-border-top-colors" rel="external nofollow noreferrer">Mozilla Developer Network</a></p>
<h3>混合属性</h3>
<h4>-webkit-user-select 和 -moz-user-select</h4>
<p>或许你常常不希望用户在你的网站上选择文本，无论是否是出于版权的原因。通常大家会有js来实现，另一个方案就是，将-webkit-user-select 和-moz-user-select 的值设为none。</p>
<p>请谨慎使用这个属性：因为大部分用户是来查看信息的，他们可以复制并存储下来以备将来之用，所以这种方法既无用也无效。如果你禁用了复制粘贴功能，用户还是可以通过查看源文件来获取到他们想要的内容。搞不懂这个属性为什么会被webkit和gecko支持。</p>
<p><strong>浏览器支持</strong>: WebKit, Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/css/property/-webkit-text-stroke" rel="external nofollow noreferrer">Safari Developer Library</a>,&nbsp;<a href="https://developer.mozilla.org/en/CSS/-moz-user-select" rel="external nofollow noreferrer">Mozilla Developer Network</a></p>
<h4>-webkit-appearance 和 -moz-appearance</h4>
<p>你曾经想过将一张图片伪装成单选按钮么？或者，一个输入框看起来像一个复选框？那么现在appearance 出现了。即便你并不想要让一个链接看起来总是像个按钮，下面这个例子也可以让你了解到，只要你愿意就可以做到的：</p>
<p><strong>示例</strong></p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">a {<br />
-webkit-appearance: button;<br />
-moz-appearance: button;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>浏览器支持</strong>: WebKit, Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/css/property/-webkit-text-stroke" rel="external nofollow noreferrer">Safari Developer Library</a>,&nbsp;<a href="https://developer.mozilla.org/en/CSS/-moz-appearance" rel="external nofollow noreferrer">Mozilla Developer Network</a>,&nbsp;<a href="https://developer.mozilla.org/en/CSS/text-align" rel="external nofollow noreferrer">Mozilla Developer Network</a>,<a href="http://www.qianduan.net/css3-appearance.html" rel="external nofollow noreferrer">CSS3 appearance简介</a></p>
<h4>text-align: -moz-center/-webkit-center</h4>
<p>这是一个属性（或者精确来说，是个&ldquo;属性值&rdquo;）的存在很让人惊喜啊。要让一个块级元素居中，大家通常将其设置为margin:0 auto。但是，现在你也可以将元素的容器的text-align属性设置为-moz-center 和 -webkit-center。相应的，你也可以通过设置-moz-left、-webkit-left或-moz-right、-webkit-right将元素居左或者居右。</p>
<p><strong>浏览器支持</strong>: WebKit, Gecko.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-text-align" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h3>CSS 2.1属性</h3>
<h4>counter-increment</h4>
<p>你是否经常希望你可以让一个有序列表或者一篇文章的所有标题自动编号？不幸的是，目前尚未有CSS3属性支持。但是在CSS 2.1中，counter-increment 提供了一个解决方案。这就意味着它已经出现好些年了，而且在IE8中就已经支持了。</p>
<p>配合:before 伪元素和content 属性，counter-increment可以为所有的HTML标签添加自动的编号。即便是嵌套的编码也是支持的。</p>
<p><strong>示例</strong></p>
<p>要给标题编码，先将计算器重设一下:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1
</pre>
</td>
<td>
<pre class="prettyprint linenums">body {counter-reset: thecounter}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>下面的样式让每一个&lt;h1&gt;标题都有一个&rdquo;Section&rdquo;的前缀，然后其后面的数字自动的递增1(这是默认的，可以省略掉)，这里thecounter是计算器的名称:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">.counter h1:before {<br />
counter-increment: thecounter 1;<br />
content:"Section"counter(thecounter)":";<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>示例</strong></p>
<p>对于一个嵌套编码的列表，重设计数器，然后关掉&lt;ol&gt;的自动编码，因为它是无嵌套的:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">ol {<br />
counter-reset: section;<br />
list-style-type: none;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>然后，每个&lt;li&gt;设置为自动编号，分割符是一个点(.)，后面跟着一个空格</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">li:before {<br />
counter-increment: section;<br />
content: counters(section,".")"";<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>HTML代码：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4<br />
5<br />
6<br />
7<br />
8<br />
9<br />
10
</pre>
</td>
<td>
<pre class="prettyprint linenums">&lt;ol&gt;<br />
	&lt;li&gt;item&lt;/li&gt; &lt;!-- 1 --&gt;<br />
	&lt;li&gt;item &lt;!-- 2 --&gt;<br />
		&lt;ol&gt;<br />
			&lt;li&gt;item&lt;/li&gt; &lt;!-- 1.1 --&gt;<br />
			&lt;li&gt;item&lt;/li&gt; &lt;!-- 1.2 --&gt;<br />
		&lt;/ol&gt;<br />
	&lt;/li&gt;<br />
	&lt;li&gt;item&lt;/li&gt; &lt;!-- 3 --&gt;<br />
&lt;ol&gt;</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><strong>浏览器支持</strong>: CSS 2.1.，所有的现代浏览器，IE 7+.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/CSS21/generate.html#counters" rel="external nofollow noreferrer">W3C</a>，<a href="http://www.qianduan.net/css-content-counter-increment-counter-reset.html" rel="external nofollow noreferrer">CSS content, counter-increment 和 counter-reset详解</a></p>
<h4>quotes</h4>
<p>你会因为你的CMS不知道如何正确转换引用符号而纠结么？那么开始使用quotes属性吧。这样你就可以自定义任何符号了。然后你就可以用:before和:after伪元素为任何期望的元素指定引号了，悲催的是，webkit浏览器不支持这个属性&mdash;&mdash;经测试，chrome 11已经开始支持这个属性了（之前的版本没有测试）。</p>
<p><strong>示例</strong></p>
<p>前面的两个符号决定第一级引用内容的引号，后面的两个用于二级引用，以此类推：</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3
</pre>
</td>
<td>
<pre class="prettyprint linenums">q {<br />
quotes: '&laquo;' '&raquo;' "&lsaquo;" "&rsaquo;";<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>下面两行用于为选定元素指定引号:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2
</pre>
</td>
<td>
<pre class="prettyprint linenums">q:before {content: open-quote}<br />
q:after {content: close-quote}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p>这样，&lt;p&gt;&lt;q&gt;This is a very &lt;q&gt;nice&lt;/q&gt; quote.&lt;/q&gt;&lt;/p&gt;看起来将会是酱紫的： <strong>&laquo;This is a very &lsaquo;nice&rsaquo; quote.&raquo;</strong></p>
<p><strong>浏览器支持</strong>: CSS 2.1.,除了WebKit，IE 7和IE6的所有现代浏览器。不过chrome是支持的。。。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/CSS2/generate.html#quotes" rel="external nofollow noreferrer">W3C</a></p>
<p><strong>问题：</strong>要直接的添加符号，CSS文档必须要设置为UTF-8吗？这是一个很纠结的问题。遗憾的是，我不能给出一个明确的答案。我的经验是，不必要设置什么特定的字符集，然后utf-8字符集可能会出错，因为它显示错掉的字符(比如&rdquo;&raquo;&rdquo;)。而是用iso-8859-1 字符集，一切就都是正常的。</p>
<p>W3C<a href="http://www.w3.org/TR/CSS21/generate.html" rel="external nofollow noreferrer">这样描述</a>：&rdquo;由于上个例子中由&rsquo;quotes&rsquo;定义的引号方便的定位在电脑键盘上，高质量的字符则需要不同的10646字符集。&rdquo;</p>
<h3>你或许听说过但是没有记住的CSS3属性</h3>
<p>接近尾声，让我们重温一些不太流行的以及不像border-radius和box-shadow那样被广泛需求的CSS3属性。</p>
<h4>text-overflow</h4>
<p>或许你会常常遇到这个问题：某个容器对于其内的文字来说太小了，然后你不得不用javascript来截断字符串并添加&rdquo;&hellip;&rdquo;符号以避免文字溢出。</p>
<p>忘掉它吧！采用CSS3和text-overflow: ellipsis，如果文字比它的容器的宽度要长的话，你就可以强制文字以&rdquo;&hellip;&rdquo;结束它。唯一的要求是设置overflow:hidden。不幸的是，Firefox不支持这个属性，但是貌似在最近的版本中将会提供支持。</p>
<p><strong>示例</strong></p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">div {<br />
width: 100px;<br />
text-overflow: ellipsis;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/textoverflow.jpg" /></p>
<p><strong>浏览器支持</strong>: CSS 3，所有浏览器的最新版本，除了Firefox，IE从IE6开始支持，据说Firefox到6.0也会提供支持的&mdash;&mdash;希望如此吧。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/2010/WD-css3-text-20101005/#text-overflow" rel="external nofollow noreferrer">W3C</a></p>
<h4>word-wrap</h4>
<p>当文字在一个比较窄的容器中时，它的某个部分可能会因为太长而不能正确的换行。比如链接就常常引起问题。如果你不想用overflow: hidden隐藏溢出的文字，那么你就可以设置 word-wrap 为break-word，它可以让字符串在到达容器的宽度限制时换行。</p>
<p><strong>示例</strong></p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3<br />
4
</pre>
</td>
<td>
<pre class="prettyprint linenums">div {<br />
width: 50px;<br />
word-wrap: break-word;<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/wordwrap.jpg" /></p>
<p><strong>浏览器支持</strong>: CSS 3，所有现代浏览器。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/2011/WD-css3-text-20110215/#word-wrap" rel="external nofollow noreferrer">W3C</a></p>
<h4>resize</h4>
<p>如果你在使用Firefox或Chrome，那么你肯定注意到了文本框的右下角默认有个小的手柄，它可以让你调整它们的大小。这个标准的行为由CSS3 属性 resize: both实现。</p>
<p>但是它并不仅限于textarea。它可以用于所有的HTML元素。horizontal 和 vertical 值用于控制调整水平方向还是垂直方向。</p>
<p>请注意：对于display:block元素，如果设置了overflow:visible，resize属性将会无效(这一点原文描述不详&mdash;&mdash;by 神飞)。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/resize.jpg" /></p>
<p><strong>浏览器支持</strong>: CSS3, 除了Opera和IE以为的其它最新的浏览器。</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://developer.apple.com/library/safari/documentation/AppleApplications/Reference/SafariCSSRef/Articles/StandardCSSProperties.html#//apple_ref/doc/uid/TP30001266-resize" rel="external nofollow noreferrer">Safari Developer Library</a></p>
<h4>background-attachment</h4>
<p>当你为一个设置了overflow:auto的元素指定背景图片的时候，当内容太多而出现滚动条后，拖动滚动条就会发现背景图片的位置是固定的，而不是随着滚动条移动。如果你想要背景图片随着内容而滚动，可以设置background-attachment:local。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/backgroundattachment.jpg" /></p>
<p><strong>浏览器支持</strong>: CSS 3，除了Firefox以外的所有现代浏览器，Firefox是<strong>支持</strong>background-attachment属性的，只是<a href="https://developer.mozilla.org/en/CSS/background-attachment" rel="external nofollow noreferrer">不支持local值</a>.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/2011/WD-css3-text-20110215/#word-wrap" rel="external nofollow noreferrer">W3C</a></p>
<h4>text-rendering</h4>
<p>随着越来越多的网站开始用@font-face来渲染文字，易读性开始被关注了。小号字体上，文字会更容易出现。由于目前还没有CSS属性控制显示在线字体的微妙细节，你可以利用text-rendering来启用<a href="http://en.wikipedia.org/wiki/Kerning" rel="external nofollow noreferrer">kerning</a>&nbsp;和&nbsp;<a href="http://en.wikipedia.org/wiki/Typographic_ligature" rel="external nofollow noreferrer">ligatures</a>。</p>
<p>Gecko 和WebKit 浏览器处理这个属性的方式很不一样。前者默认启用这个特性，而后者，你需要将其设置为optimizeLegibility。</p>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/textrendering.jpg" /></p>
<p><strong>浏览器支持</strong>: CSS3, 所有WebKit 和Firefox浏览器.</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/2011/WD-css3-text-20110215/#word-wrap" rel="external nofollow noreferrer">W3C</a></p>
<h4>transform: rotateX/transform: rotateY</h4>
<p>如果你已经开始使用CSS3，那么你可能会比较熟悉transform: rotate()，这个在z轴上旋转元素的属性。</p>
<p>但是你是否也知道，它也可以更深入的旋转的(比如，围绕x轴和y轴)？ 这些变形结合-webkit-backface-visibility: hidden会更合适。</p>
<p><strong>示例</strong></p>
<p>如果你鼠标经过这个元素，它将会旋转180&deg;，倒转过来:</p>
<div>
<table>
<tbody>
<tr>
<td>
<pre class="prettyprint linenums">1<br />
2<br />
3
</pre>
</td>
<td>
<pre class="prettyprint linenums">div:hover {<br />
transform: rotateY(180deg);<br />
}</pre>
</td>
</tr>
</tbody>
</table>
</div>
<p><img referrerpolicy="no-referrer"src="http://img.qianduan.net/uploads/2011/05/rotate.jpg" /></p>
<p><strong>小技巧:</strong>如果只是映射一个元素，你可以设置transform为rotateX(180deg) (对应rotateY)或者设置transform 为scaleX(-1) (对应scaleY).</p>
<p><strong>浏览器支持</strong>: CSS3, WebKit、firefox、Opera以及IE9</p>
<p><strong>扩展阅读</strong>:&nbsp;<a href="http://www.w3.org/TR/2011/WD-css3-text-20110215/#word-wrap" rel="external nofollow noreferrer">W3C</a>，<a href="http://www.qianduan.net/what-you-need-to-know-about-behavioral-css.html" rel="external nofollow noreferrer">你需要知道的CSS3 动画技术</a></p>
<h3>结语</h3>
<p>正如你希望见到的，还有很多未知的很有用的属性。他们中的很多仍然处于试验性阶段并且可能一直这样甚至最终可能会被浏览器摈弃。而有些有望在后续版本中被所有的浏览器支持。</p>
<p>然而，很难判断判断他们中的一些是好是坏，WebKit特有的属性随着iOS和Android的成功显得越来越重要。当然，一些CSS3属性多多少少已经可以使用了。</p>
<p>如果你不喜欢私有属性，你可以将它们视为实验直到可以在代码中实现以增强用户体验。同时，W3C的<a href="http://lists.w3.org/Archives/Public/www-validator-css/2011Jan/0020.html" rel="external nofollow noreferrer">CSS validator</a>&nbsp;同样支持私有属性，它会返回警告而不是错误。</p>
<p>祝你体验快乐！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8ojyj1q.html">Java&lowbar;File类讲解&lowbar;打印目录树状结构&lowbar;递归算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1lnr28.html">Apache-Jemeter web性能测试工具使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7rz4k8.html">Nagios学习笔记四&colon;基于NRPE监控远程Linux主机</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yzr55q.html">在windows系统上安装caffe</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvw46q.html">Python3 字符编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04yjgq.html">跟我一起学CMake</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn172oj8.html">从一道面试题谈linux下fork的运行机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyde3m2q.html">Node&period;js笔记2</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpr3279.html">【二十二】mysqli事务处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/950ny768.html">ArcGIS 网络分析&lbrack;2&period;1&rsqb; 最短路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7mjlq.html">面试容易问到的Linux问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjm40z9.html">使用sed在匹配行之后增加一行数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wpnezq.html">celery任务进程关闭</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvnwkj8.html">Echars鼠标点击事件多次触发</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wj4lwq.html">「2017 Multi-University Training Contest 1」2017多校训练1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyxnkjq.html">docker 构建dockerfile</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6lnj9.html">机器学习中的规则化范数&lpar;L0&comma; L1&comma; L2&comma; 核范数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy7x1gq.html">Spring Batch 批量处理策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj22zz9.html">Materix3&ast;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/960167n9.html">axios请求拦截及请求超时重新请求设置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnwd2j8.html">C&plus;&plus;之路进阶&mdash;&mdash;codevs1204（寻找子串位置）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdzn2d8.html">shp图层创建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmeo219.html">jquery选项卡切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v7dx38.html">夺命雷公狗---node&period;js---6net模块玩telnet通信（下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnwe1d8.html">50136142WXY的百度地图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnmwmpq.html">kernel32&period;dll出错解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k102dj9.html">git-gui</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnwymv8.html">JeeSite开发笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmewjx9.html">160928、JQuery解析XML数据的demo</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv57jxq.html">Hive报错之java&period;sql&period;SQLException&colon; Field &amp;&num;39&semi;IS&lowbar;STOREDASSUBDIRECTORIES&amp;&num;39&semi; doesn&amp;&num;39&semi;t have a default value</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
